#键盘上位机
#三方库安装命令: pip install pyserial
import serial
import serial.tools.list_ports
from time import sleep
from tkinter import ttk

def 设置按键(端口, 命令):
    sleep(0.1)
    状态 = ""
    try:
        ser = serial.Serial(端口, 115200)
        状态 = "已打开串口"
    except:
        print("打开串口失败")
        状态 = "打开串口失败"

    if 状态 == "已打开串口":
        # 要发送的16进制数据
        hex_data = 命令
        # 将16进制字符串转换为字节序列
        bytes_to_send = bytes.fromhex(''.join(hex_data.split()))
        ser.write(bytes_to_send)
        sleep(0.5)
        line = ser.readline().decode('utf-8').rstrip()
        ser.close()
        return "OK", line
    else:
        return "Error", 状态

import tkinter as tk
from tkinter.messagebox import showerror as 错误弹窗
from tkinter.messagebox import showinfo as 提示弹窗

# 创建一个新的窗口
window = tk.Tk()

# 给窗口设置标题
window.title("菜狗键盘上位机")

# 设置窗口的大小（宽度x高度）
window.geometry("500x300")

def 数据分析(临时数据):
    错误弹窗("错误", "数据3不正确,当数据1为'01'时数据3必须为'00'")
    提示弹窗("提示", "写入成功")

def 数据栏位生成():
    数据 = []
    for i in range(6):
        数据2 = []
        for ii in range(9):
            数据2.append("数据" + str(i) + str(ii))
        数据.append(数据2)
    return 数据

数据 = 数据栏位生成()
X标签 = ["1","2","3","4","5","6","7","8","9"]
Y标签 = ["按键1","按键2","按键3","按键4","顺时针","逆时针"]
按钮 = ["按钮0","按钮1","按钮2","按钮3","按钮4","按钮5"]
按键地址 = ["00", "02", "04", "06", "08", "0A"]

默认键码0 = ["02", "B6", "00", "00", "00", "00", "00", "00", "00"]
默认键码1 = ["02", "CD", "00", "00", "00", "00", "00", "00", "00"]
默认键码2 = ["02", "B5", "00", "00", "00", "00", "00", "00", "00"]
默认键码3 = ["01", "05", "00", "0E", "00", "00", "00", "00", "00"]
默认键码4 = ["02", "E9", "00", "00", "00", "00", "00", "00", "00"]
默认键码5 = ["02", "EA", "00", "00", "00", "00", "00", "00", "00"]
默认键码 = [默认键码0,默认键码1,默认键码2,默认键码3,默认键码4,默认键码5]

def 点击按钮(键号1):
    临时数据 = []
    命令 = "59 59 01 " + 按键地址[键号1]
    for i in range(9):
        if 数据[键号1][i].get() == "":
            临时数据.append("00")
            命令 = 命令 + " 00"
        else:
            临时数据.append(数据[键号1][i].get())
            命令 = 命令 + " " + 数据[键号1][i].get()
    命令 = 命令 + " 43 47"
    #端口 = 端口号.get()
    端口 = 下拉列表.get()
    print(端口,命令,临时数据)
    #数据分析(临时数据)
    返回 = 设置按键(端口, 命令)
    if 返回[0] == "OK":
        提示弹窗(返回[0], 返回[1])
    else:
        错误弹窗("错误", 返回[1])

端口标签 = tk.Label(window, text="端口:", font=('Arial', 12))
端口标签.place(x=5, y=8)

#端口号 = tk.Entry(window,width=8, font=('Arial', 16))
#端口号.place(x=60, y=5)

def 刷新串口():
    串口列表 = list(serial.tools.list_ports.comports())
    串口列表2 = []
    for 串口 in 串口列表:
        # 打印每个串口的名称、设备号和供应商信息
        #print("串口名称:", 串口.device)
        #print("供应商信息:", 串口.manufacturer)
        串口列表2.append(串口.device)
    return 串口列表2

#串口列表 = 刷新串口()
下拉列表 = ttk.Combobox(window, width=7, textvariable='端口:', font=('Arial', 16))
下拉列表["values"] = 刷新串口()
#下拉列表.current(0)
下拉列表.place(x=60, y=5)

def 刷新串口2():
    print(刷新串口())
    下拉列表["values"] = 刷新串口()

串口刷新按钮 = tk.Button(window, text="刷新", command=刷新串口2)
串口刷新按钮.place(x=170, y=5)

for i in range(9):
    X标签[i] = tk.Label(window, text=X标签[i], font=('Arial', 16))
    X标签[i].place(x=70+i*45, y=38)

for i in range(6):
    Y标签[i] = tk.Label(window, text=Y标签[i], font=('Arial', 12))
    Y标签[i].place(x=5, y=72+i*38)

for i in range(6):
    for ii in range(9):
        数据[i][ii] = tk.Entry(window,width=3, font=('Arial', 16))
        数据[i][ii].insert(0, 默认键码[i][ii])
        数据[i][ii].place(x=60+ii*45, y=70+i*38)

for i in range(6):
    按钮[i] = tk.Button(window, text="写入", command=lambda e=i:点击按钮(e))
    按钮[i].place(x=462, y=69+i*38)# 将按钮放置在窗口上

# 开始事件循环
window.mainloop()